//------------------------------------------------------------------+
//#property copyright "www.forex-tsd.com"                           |
//#property link      "www.forex-tsd.com"                           |
// original idea fr this indicator by Dan Valcu                     |
//------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  Lime
#property indicator_color2  Orange
#property indicator_color3  DimGray
#property indicator_color4  Red
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_color7  DimGray
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style7  STYLE_DASH

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[], double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern string  TimeFrame              = "Current time frame";
extern bool    BetterFormula          = false;
extern int     SignalPeriod           = 7;
extern int     SignalMethod           = MODE_SMA;
extern int     DzLookBackBars         = 70;
extern double  DzStartBuyProbability  = 0.01;
extern double  DzStartSellProbability = 0.01;
extern bool    alertsOn               = true;
extern bool    alertsOnDzZeroCross    = true;
extern bool    alertsOnSignalCross    = true;
extern bool    alertsOnCurrent        = true;
extern bool    alertsMessage          = true;
extern bool    alertsSound            = false;
extern bool    alertsNotify           = false;
extern bool    alertsEmail            = false;
extern bool    arrowsVisible          = false;
extern bool    arrowsOnDzZeroCross    = true;
extern bool    arrowsOnSignalCross    = true;
extern string  arrowsIdentifier       = "haDelta arrows1";
extern double  arrowsUpperGap         = 1.0;
extern double  arrowsLowerGap         = 1.0;
extern color   arrowsUpColor          = LimeGreen;
extern color   arrowsDnColor          = Red;
extern int     arrowsUpCode           = 241;
extern int     arrowsDnCode           = 242;
extern bool    arrowsOnFirst          = true;
extern bool    Interpolate            = true;

//
//
//
//
//

double haUp[];
double haDn[];
double haDelta[];
double haSignal[];
double sli[];
double bli[];
double zli[];
double trend1[];
double trend2[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,haUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,haDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,haDelta);
   SetIndexBuffer(3,haSignal);
   SetIndexBuffer(4,bli);
   SetIndexBuffer(5,sli);
   SetIndexBuffer(6,zli);
   SetIndexBuffer(7,trend1);
   SetIndexBuffer(8,trend2);
   
   timeFrame         = stringToTimeFrame(TimeFrame);
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame=="returnBars");
   IndicatorShortName(timeFrameToString(timeFrame)+" Dynamic zone of haDelta histo ");
return(0);
}

int deinit()
{
   deleteArrows();

return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int countedBars = IndicatorCounted();
      if(countedBars<0) return(-1);
      if(countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);
         if (returnBars) { haUp[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);
                  haUp[i]     = iCustom(NULL,timeFrame,indicatorFileName,"",BetterFormula,SignalPeriod,SignalMethod,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,alertsOn,alertsOnDzZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsOnDzZeroCross,arrowsOnSignalCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnFirst,0,y);
                  haDn[i]     = iCustom(NULL,timeFrame,indicatorFileName,"",BetterFormula,SignalPeriod,SignalMethod,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,alertsOn,alertsOnDzZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsOnDzZeroCross,arrowsOnSignalCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnFirst,1,y);
                  haDelta[i]  = iCustom(NULL,timeFrame,indicatorFileName,"",BetterFormula,SignalPeriod,SignalMethod,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,alertsOn,alertsOnDzZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsOnDzZeroCross,arrowsOnSignalCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnFirst,2,y);
                  haSignal[i] = iCustom(NULL,timeFrame,indicatorFileName,"",BetterFormula,SignalPeriod,SignalMethod,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,alertsOn,alertsOnDzZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsOnDzZeroCross,arrowsOnSignalCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnFirst,3,y);
                  bli[i]      = iCustom(NULL,timeFrame,indicatorFileName,"",BetterFormula,SignalPeriod,SignalMethod,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,alertsOn,alertsOnDzZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsOnDzZeroCross,arrowsOnSignalCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnFirst,4,y);
                  sli[i]      = iCustom(NULL,timeFrame,indicatorFileName,"",BetterFormula,SignalPeriod,SignalMethod,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,alertsOn,alertsOnDzZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsOnDzZeroCross,arrowsOnSignalCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnFirst,5,y);
                  zli[i]      = iCustom(NULL,timeFrame,indicatorFileName,"",BetterFormula,SignalPeriod,SignalMethod,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,alertsOn,alertsOnDzZeroCross,alertsOnSignalCross,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,arrowsVisible,arrowsOnDzZeroCross,arrowsOnSignalCross,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsOnFirst,6,y);
                  
                  //
                  //
                  //
                  //
                  //
                  
                  if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
                  
                  //
                  //
                  //
                  //
                  //
                  
                  datetime time = iTime(NULL,timeFrame,y);
                     for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
                     for(int k = 1; k < n; k++)
                     {
                        haDelta[i+k]  = haDelta[i]  + (haDelta[i+n]  - haDelta[i])  * k/n;
                        haSignal[i+k] = haSignal[i] + (haSignal[i+n] - haSignal[i]) * k/n;
                        bli[i+k]      = bli[i]      + (bli[i+n]      - bli[i])      * k/n;
                        sli[i+k]      = sli[i]      + (sli[i+n]      - sli[i])      * k/n;
                        zli[i+k]      = zli[i]      + (zli[i+n]      - zli[i])      * k/n;
                        if (haUp[i+k] != EMPTY_VALUE) haUp[i+k] = haDelta[i+k];
                        if (haDn[i+k] != EMPTY_VALUE) haDn[i+k] = haDelta[i+k];
                     }
            }
            return(0);
         }
               
   //
   //
   //
   //
   //
   
   for (i=limit; i >= 0; i--)
   {
       if (BetterFormula) {
             if (High[i] != Low[i])
                  double haClose = (Open[i]+Close[i])*0.50+(((Close[i]-Open[i])/(High[i]-Low[i]))*MathAbs((Close[i]-Open[i])*0.50));
                  else   haClose = (Open[i]+Close[i])*0.50; }
       else              haClose = (Open[i]+High[i]+Low[i]+Close[i])*0.25;
                  double haOpen  = (Open[i+1]+Close[i+1])*0.50;

       //
       //
       //
       //
       //
         
       haDelta[i] = haClose-haOpen;
       bli[i]     = dzBuyP (haDelta, DzStartBuyProbability,  DzLookBackBars, Bars, i, 0.0001);
       sli[i]     = dzSellP(haDelta, DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
       zli[i]     = dzSellP(haDelta, 0.5,                    DzLookBackBars, Bars, i, 0.0001);
       haUp[i]    = EMPTY_VALUE;
       haDn[i]    = EMPTY_VALUE;
       trend1[i]  = trend1[i+1];
         if (haDelta[i]>zli[i]) trend1[i] = 1;
         if (haDelta[i]<zli[i]) trend1[i] =-1; 
         if (trend1[i] == 1)    haUp[i] = haDelta[i];
         if (trend1[i] ==-1)    haDn[i] = haDelta[i];
        
         
   }
   for (i=limit; i >= 0; i--)
   {
      haSignal[i] = iMAOnArray(haDelta,0,SignalPeriod,0,SignalMethod,i);
      trend2[i]   = trend2[i+1];
        if (haDelta[i]>haSignal[i]) trend2[i] = 1;
        if (haDelta[i]<haSignal[i]) trend2[i] =-1;
        
        //
        //
        //
        //
        //
        
        if (arrowsVisible)
        {
          ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
          ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
          string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
          if (arrowsOnDzZeroCross && trend1[i] != trend1[i+1])
          {
            if (trend1[i] == 1) drawArrow("1",0.5,i,arrowsUpColor,arrowsUpCode,false);
            if (trend1[i] ==-1) drawArrow("1",0.5,i,arrowsDnColor,arrowsDnCode, true);
          } 
          if (arrowsOnSignalCross && trend2[i] != trend2[i+1])
          {
            if (trend2[i] == 1) drawArrow("2",1,i,arrowsUpColor,arrowsUpCode,false);
            if (trend2[i] ==-1) drawArrow("2",1,i,arrowsDnColor,arrowsDnCode, true);
          }                              
       }         
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnDzZeroCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar," crossed dynamic zero line up ");
            if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar," crossed dynamic zero line down ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnSignalCross && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar," crossed signal line up ");
            if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar," crossed signal line down ");
         }            
   }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ",timeFrameToString(Period())+" haDelta ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"haDelta "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}